diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index c2bbff2fe..de85fed6c 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -1050,15 +1050,15 @@ public class Block
     public static final Block algae = new BlockAlgae("algae", 324, Material.plant).withHardness(0.0F).withLitInteriorSurface(true)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH);
 
-    public static final Block flowerYellow = new BlockFlower("flower.yellow", 330).setKilledByWeather().withHardness(0.0F)
+    public static final Block flowerYellow = new BlockFlower("flower.yellow", 330).setKilledByWeather().setBonemealable().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
-    public static final Block flowerRed = new BlockFlower("flower.red", 331).setKilledByWeather().withHardness(0.0F)
+    public static final Block flowerRed = new BlockFlower("flower.red", 331).setKilledByWeather().setBonemealable().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
-    public static final Block flowerPink = new BlockFlower("flower.pink", 332).setKilledByWeather().withHardness(0.0F)
+    public static final Block flowerPink = new BlockFlower("flower.pink", 332).setKilledByWeather().setBonemealable().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
-    public static final Block flowerPurple = new BlockFlower("flower.purple", 333).setKilledByWeather().withHardness(0.0F)
+    public static final Block flowerPurple = new BlockFlower("flower.purple", 333).setKilledByWeather().setBonemealable().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
-    public static final Block flowerLightBlue = new BlockFlower("flower.lightblue", 334).setKilledByWeather().withHardness(0.0F)
+    public static final Block flowerLightBlue = new BlockFlower("flower.lightblue", 334).setKilledByWeather().setBonemealable().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
 
     public static final Block mushroomBrown = new BlockMushroom("mushroom.brown", 340).withHardness(0.0F).withLightEmission(0.125F)
diff --git a/src/main/java/net/minecraft/core/block/BlockFlower.java b/src/main/java/net/minecraft/core/block/BlockFlower.java
index d371b0fbf..4852eefa9 100644
--- a/src/main/java/net/minecraft/core/block/BlockFlower.java
+++ b/src/main/java/net/minecraft/core/block/BlockFlower.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.IBonemealable;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
@@ -13,11 +17,12 @@ import java.util.Random;
 //            Block, Material, World, BlockGrass, 
 //            AxisAlignedBB
 
-public class BlockFlower extends Block
+public class BlockFlower extends Block implements IBonemealable
 {
 
 	public boolean killedByWeather = false;
-	
+	public boolean canBeBonemealed = false;
+
 	public BlockFlower(String key, int id)
     {
         super(key, id, Material.plant);
@@ -26,11 +31,16 @@ public class BlockFlower extends Block
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 3F, 0.5F + f);
     }
     
-    public Block setKilledByWeather()
+    public BlockFlower setKilledByWeather()
     {
     	killedByWeather = true;
     	return this;
     }
+    public BlockFlower setBonemealable()
+    {
+        canBeBonemealed = true;
+        return this;
+    }
 
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
@@ -95,4 +105,44 @@ public class BlockFlower extends Block
         return false;
     }
 
+    @Override
+    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        Random rand = world.rand;
+        if(!world.isClientSide && canBeBonemealed)
+        {
+            if (entityplayer.getGamemode().consumeBlocks())
+            {
+                itemstack.stackSize--;
+            }
+            label0:
+            for(int j1 = 0; j1 < 128; j1++)
+            {
+                int k1 = blockX;
+                int l1 = blockY;
+                int i2 = blockZ;
+                for(int j2 = 0; j2 < j1 / 16; j2++)
+                {
+                    k1 += rand.nextInt(3) - 1;
+                    l1 += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
+                    i2 += rand.nextInt(3) - 1;
+                    int id1 = world.getBlockId(k1, l1 - 1, i2);
+                    if(Block.blocksList[id1] == null || !Block.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS))
+                    {
+                        continue label0;
+                    }
+                }
+
+                if(world.getBlockId(k1, l1, i2) != 0)
+                {
+                    continue;
+                }
+                if(rand.nextFloat() > 0.75)
+                {
+                    world.setBlockWithNotify(k1, l1, i2, id);
+                }
+            }
+            return true;
+        }
+        return canBeBonemealed;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockGlowStone.java b/src/main/java/net/minecraft/core/block/BlockGlowStone.java
index 173b93f7a..09d18b186 100644
--- a/src/main/java/net/minecraft/core/block/BlockGlowStone.java
+++ b/src/main/java/net/minecraft/core/block/BlockGlowStone.java
@@ -6,6 +6,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Item, Material
@@ -30,4 +31,9 @@ public class BlockGlowStone extends Block
                 return new ItemStack[] { new ItemStack(Item.dustGlowstone, 2 + world.rand.nextInt(2)) };
         }
     }
+    
+    @Override
+    public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+    	return 0.0f;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockGrass.java b/src/main/java/net/minecraft/core/block/BlockGrass.java
index 2df3323fe..d0317fe91 100644
--- a/src/main/java/net/minecraft/core/block/BlockGrass.java
+++ b/src/main/java/net/minecraft/core/block/BlockGrass.java
@@ -11,6 +11,8 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.noise.ImprovedNoise;
 
 // Referenced classes of package net.minecraft.src:
@@ -61,6 +63,15 @@ public class BlockGrass extends Block
                     idToSpawn = Block.flowerRed.id;
                 } else if (r < 41) {
                     idToSpawn = Block.flowerYellow.id;
+                } else if (r < 60) {
+                    Biome biome = world.getBlockBiome(x, y + 1, z);
+                    if (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST){
+                        idToSpawn = Block.flowerPink.id;
+                    } else if (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND) {
+                        idToSpawn = Block.flowerPurple.id;
+                    } else if (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA) {
+                        idToSpawn = Block.flowerLightBlue.id;
+                    }
                 } else {
                     if(rand.nextInt(8) == 0) {
                         idToSpawn = Block.tallgrassFern.id;
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
index dc177788e..8e0b0207d 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
@@ -188,8 +188,9 @@ public abstract class BlockLeavesBase extends Block
     
     @Override
     public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
-    	return 1.0f;
+    	return enableTreeShadowing ? 0.8f : 0.0f;
     }
 
+    public static boolean enableTreeShadowing = false;
     int[] adjacentTreeBlocks;
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockMud.java b/src/main/java/net/minecraft/core/block/BlockMud.java
index 142598a1c..ba6819318 100644
--- a/src/main/java/net/minecraft/core/block/BlockMud.java
+++ b/src/main/java/net/minecraft/core/block/BlockMud.java
@@ -162,12 +162,13 @@ public class BlockMud extends Block{
     @Override
     public void updateTick(final World world, final int x, final int y, final int z, final Random rand)
     {
-        tryToFall(world, x, y, z);
         // dry out mud
         if(isHardened) {
             if(!isLavaNearby(world, x, y, z)) {
                 if (canBecomeWet(world, x, y, z)) {
                     world.setBlock(x, y, z, Block.mud.id);
+                    world.notifyBlockChange(x, y, z, Block.mud.id);
+                    return;
                 }
             }
         }
@@ -180,8 +181,11 @@ public class BlockMud extends Block{
                     world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D);
                 }
                 world.setBlock(x, y, z, Block.mudBaked.id);
+                world.notifyBlockChange(x, y, z, Block.mudBaked.id);
+                return;
             }
         }
+        tryToFall(world, x, y, z);
     }
 
 
diff --git a/src/main/java/net/minecraft/core/block/BlockStairs.java b/src/main/java/net/minecraft/core/block/BlockStairs.java
index ea26a6f61..bcae219a6 100644
--- a/src/main/java/net/minecraft/core/block/BlockStairs.java
+++ b/src/main/java/net/minecraft/core/block/BlockStairs.java
@@ -302,6 +302,11 @@ public class BlockStairs extends Block
 
         world.setBlockMetadataWithNotify(x, y, z, meta);
     }
+    
+    @Override
+    public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+    	return 0.0f;
+    }
 
     public Block modelBlock;
 }
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 3e6853b5e..1817e7995 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -9,6 +9,7 @@ import com.mojang.nbt.FloatTag;
 import com.mojang.nbt.ListTag;
 
 import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFluid;
@@ -16,6 +17,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.DamageType;
@@ -799,6 +801,17 @@ public abstract class Entity
             return entityBrightness;
         }
     }
+    
+    public int getLightmapCoord(float partialTicks) {
+    	int blockX = MathHelper.floor_double(x);
+    	int blockY = MathHelper.floor_double(y);
+    	int blockZ = MathHelper.floor_double(z);
+    	
+    	int skylight = world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ);
+    	int blocklight = world.getSavedLightValue(LightLayer.Block, blockX, blockY, blockZ);
+    	
+    	return LightmapHelper.getLightmapCoord(skylight, blocklight);
+    }
 
     public void setWorld(World world)
     {
diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
index a4efec458..973776d4a 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
@@ -560,6 +560,7 @@ public abstract class EntityPlayer extends EntityLiving
     }
 
     public void displayGUIMobSpawnerPicker(int x, int y, int z) { }
+    public void displayGUIWandMonsterPicker(ItemStack stack) { }
 
     public void onItemPickup(Entity entity, int i)
     {
diff --git a/src/main/java/net/minecraft/core/item/IBonemealable.java b/src/main/java/net/minecraft/core/item/IBonemealable.java
index 68c3b6767..0e2bc51ad 100644
--- a/src/main/java/net/minecraft/core/item/IBonemealable.java
+++ b/src/main/java/net/minecraft/core/item/IBonemealable.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index 1e9991be0..3086c9d15 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -427,6 +427,7 @@ public class Item
     public static Item doorGlass = (new ItemDoor("door.glass", 16533, Block.doorGlassBottom, Block.doorGlassTop));
     public static Item rope = new ItemRope("rope", 16534, Block.rope);
     public static Item foodPumpkinPie = (new ItemPlaceable("food.pumpkin_pie", 16535, Block.pumpkinPie)).setMaxStackSize(1);
+    public static Item wandMonsterSpawner = (new ItemWandSpawner("wand.monster", 16536)).setMaxStackSize(1);
 
 
     public static int highestItemId = 0;
diff --git a/src/main/java/net/minecraft/core/item/ItemDye.java b/src/main/java/net/minecraft/core/item/ItemDye.java
index a542d6d28..128d44818 100644
--- a/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -11,6 +11,8 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldTypes;
 
 public class ItemDye extends Item
@@ -125,18 +127,23 @@ label0:
                                     world.getBlockId(k1, l1-1, i2) == Block.dirtScorchedRich.id)
                                 world.setBlockWithNotify(k1, l1, i2, Block.spinifex.id);
                             else
-                            world.setBlockWithNotify(k1, l1, i2, Block.tallgrass.id);
+                                world.setBlockWithNotify(k1, l1, i2, Block.tallgrass.id);
                             continue;
                         }
-                        if(itemRand.nextInt(3) != 0)
-                        {
+                        int r = itemRand.nextInt(10);
+                        Biome biome = world.getBlockBiome(k1, l1, i2);
+                        if (r < 1){
                             world.setBlockWithNotify(k1, l1, i2, Block.flowerYellow.id);
-                        } else
-                        {
+                        } else if (r < 2) {
                             world.setBlockWithNotify(k1, l1, i2, Block.flowerRed.id);
+                        } else if (r < 4 && (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST)) {
+                            world.setBlockWithNotify(k1, l1, i2, Block.flowerPink.id);
+                        } else if (r < 6 && (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND)) {
+                            world.setBlockWithNotify(k1, l1, i2, Block.flowerPurple.id);
+                        } else if (r < 8 && (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA)) {
+                            world.setBlockWithNotify(k1, l1, i2, Block.flowerLightBlue.id);
                         }
                     }
-
                 }
                 return true;
             }
diff --git a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
new file mode 100644
index 000000000..70e0fc930
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -0,0 +1,47 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class ItemWandSpawner extends Item{
+    public ItemWandSpawner(String name, int id) {
+        super(name, id);
+    }
+    @Override
+    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    {
+        if (entityplayer.gamemode != Gamemode.creative){
+            entityplayer.sendTranslatedChatMessage("wand.wrongmode");
+            return itemstack;
+        }
+        entityplayer.displayGUIWandMonsterPicker(itemstack);
+
+        return itemstack;
+    }
+
+    @Override
+    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    {
+        if (entityplayer.gamemode != Gamemode.creative){
+            entityplayer.sendTranslatedChatMessage("wand.wrongmode");
+            return false;
+        }
+        if (!world.isClientSide){
+            String id = itemstack.getData().getString("monster");
+            if (id == null || id.isEmpty()){
+                id = "Pig";
+            }
+            Entity entity = EntityDispatcher.createEntityInWorld(id, world);
+            if (entity != null){
+                entity.setPos(blockX + side.getOffsetX() + 0.5f, blockY + side.getOffsetY(), blockZ + side.getOffsetZ() + 0.5f);
+                entity.spawnInit();
+                world.entityJoinedWorld(entity);
+            }
+        }
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/sound/BlockSounds.java b/src/main/java/net/minecraft/core/sound/BlockSounds.java
index c3ac8f167..149c96e10 100644
--- a/src/main/java/net/minecraft/core/sound/BlockSounds.java
+++ b/src/main/java/net/minecraft/core/sound/BlockSounds.java
@@ -10,7 +10,7 @@ public abstract class BlockSounds
     public static final BlockSound METAL = new BlockSound("step.stone", "step.stone", 1.0F, 1.5F);
     public static final BlockSound GLASS = new BlockSound("step.stone", "random.glass", 1.0F, 1.0F);
     public static final BlockSound CLOTH = new BlockSound("step.cloth", "step.cloth", 1.0F, 1.0F);
-    public static final BlockSound SAND = new BlockSound("step.sand", "step.gravel", 1.0F, 1.0F);
+    public static final BlockSound SAND = new BlockSound("step.sand", "step.sand", 1.0F, 1.0F);
     public static final BlockSound FIRE = new BlockSound("", "random.fizz", 0.5F, 2.6F);
 
 }
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 39c84d7c1..7df0318d5 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1095,6 +1095,22 @@ public class World implements WorldSource {
 		int skyLight = getSavedLightValue(LightLayer.Sky, x, y, z);
 		int blockLight = Math.max(getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
 		
+		if(getBlockLitInteriorSurface(x, y, z)) {
+			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y + 1, z));
+			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y - 1, z));
+			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x + 1, y, z));
+			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x - 1, y, z));
+			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y, z + 1));
+			skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y, z - 1));
+			
+			blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y + 1, z));
+			blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y - 1, z));
+			blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x + 1, y, z));
+			blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x - 1, y, z));
+			blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y, z + 1));
+			blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y, z - 1));
+		}
+		
 		return LightmapHelper.getLightmapCoord(skyLight, blockLight);
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 712560b4a..86b6079a2 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.chunk;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
@@ -114,7 +115,23 @@ public class ChunkCache
 		int skyLight = worldObj.getSavedLightValue(LightLayer.Sky, x, y, z);
 		int blockLight = Math.max(worldObj.getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
 		
-		return skyLight << 20 | blockLight << 4;
+		if(getBlockLitInteriorSurface(x, y, z)) {
+			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y + 1, z));
+			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y - 1, z));
+			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x + 1, y, z));
+			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x - 1, y, z));
+			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y, z + 1));
+			skyLight = Math.max(skyLight, worldObj.getSavedLightValue(LightLayer.Sky, x, y, z - 1));
+			
+			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y + 1, z));
+			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y - 1, z));
+			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x + 1, y, z));
+			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x - 1, y, z));
+			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y, z + 1));
+			blockLight = Math.max(blockLight, worldObj.getSavedLightValue(LightLayer.Block, x, y, z - 1));
+		}
+		
+		return LightmapHelper.getLightmapCoord(skyLight, blockLight);
 	}
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 453ba9673..500c7c9df 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -162,6 +162,12 @@ public class SurfaceGeneratorOverworld
                                 topBlock = (short) Block.sand.id;
                                 fillerBlock = (short) Block.sand.id;
                             }
+                        } else if (y <= oceanY) {
+                            if(biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY) // Make mud under the ocean always be regular mud
+                            {
+                                topBlock = (short) Block.mud.id;
+                                fillerBlock = (short) Block.mud.id;
+                            }
                         }
 
                         //failsafe so that if a basin is generated under the ocean, the ocean is not replaced with air
